    PROGRAM f07aufe

!      F07AUF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : nag_wp, x02ajf, zgecon, zgetrf, zlange => f06uaf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
       CHARACTER (1), PARAMETER        :: norm = '1'
!      .. Local Scalars ..
       REAL (KIND=nag_wp)              :: anorm, rcond
       INTEGER                         :: i, info, lda, n
!      .. Local Arrays ..
       COMPLEX (KIND=nag_wp), ALLOCATABLE :: a(:,:), work(:)
       REAL (KIND=nag_wp), ALLOCATABLE :: rwork(:)
       INTEGER, ALLOCATABLE            :: ipiv(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F07AUF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n
       lda = n
       ALLOCATE (a(lda,n),work(2*n),rwork(2*n),ipiv(n))

!      Read A from data file

       READ (nin,*) (a(i,1:n),i=1,n)

!      Compute norm of A
!      f06uaf is the NAG name equivalent of the LAPACK auxiliary zlange
       anorm = zlange(norm,n,n,a,lda,rwork)

!      Factorize A
!      The NAG name equivalent of zgetrf is f07arf
       CALL zgetrf(n,n,a,lda,ipiv,info)

       WRITE (nout,*)
       IF (info==0) THEN

!         Estimate condition number

!         The NAG name equivalent of zgecon is f07auf
          CALL zgecon(norm,n,a,lda,anorm,rcond,work,rwork,info)

          IF (rcond>=x02ajf()) THEN
             WRITE (nout,99999) 'Estimate of condition number =', &
                1.0_nag_wp/rcond
          ELSE
             WRITE (nout,*) 'A is singular to working precision'
          END IF
       ELSE
          WRITE (nout,*) 'The factor U is singular'
       END IF

99999  FORMAT (1X,A,1P,E10.2)
    END PROGRAM f07aufe
